#####################################
#         hTP_SimpleDM Bank         #
#####################################

import es
import playerlib
import langlib
from configobj import ConfigObj
from htp_dm.htp_dm import connection
from htp_dm import htp_dm


info = es.AddonInfo()
info.name        = "hTP_SimpleDM ba_bank option"
info.version     = "v1.1"
info.author      = "HitThePipe"
info.url         = "http://forums.mattie.info/cs/forums/"
info.description = "ba_bank option for hTP_SimpleDM"

dm_config = ConfigObj(es.getAddonPath('htp_dm') + '/dm_config.ini')
dm_lang = langlib.Strings(es.getAddonPath('htp_dm') + '/dm_lang.ini')

try:
    ba_config = ConfigObj(es.getAddonPath('ba_bank') + '/config/config.ini')
    dbba = connection(es.getAddonPath('ba_bank') + '/data/ba_bank.db')
except:
    es.dbgmsg(0, '***** BA_BANK does not exist *****')
    es.dbgmsg(0, '***** Unloading htp_dm bank option')
    es.unload('htp_dm/bank')

es.dbgmsg(1, '****start ba_bank setup')

maxbalance = int(ba_config['settings']['bank_max_balance'])
minbalance = int(ba_config['settings']['bank_start_balance'])
ignoremax = int(dm_config['settings']['bank_settings']['ignore_max_balance'])
headshotbonus = int(dm_config['settings']['bank_settings']['headshot_cash_award'])
noawpbonus = int(dm_config['settings']['bank_settings']['allow_awp_headshot_award'])
knifebonus = int(dm_config['settings']['bank_settings']['knife_cash_award'])
knifepenalty = int(dm_config['settings']['bank_settings']['knife_death_penalty'])
prefix = ('#green' + dm_config['settings']['message_prefix'] + '#default')

if int(dm_config['settings']['bank_settings']['kill_cash_award']):
    killcash = int(dm_config['settings']['bank_settings']['kill_cash_award'])
else:
    killcash = int(ba_config['settings']['bank_min_deposit'])
es.dbgmsg(1, '***** ba_bank setup successful')

es.loadevents('declare','addons/eventscripts/htp_dm/htp_dm.res')
es.loadevents('addons/eventscripts/htp_dm/htp_dm.res')

def es_map_start(event_var):
    es.loadevents('addons/eventscripts/htp_dm/htp_dm.res')
			
def round_end(event_var):
    es.dbgmsg(1,'*****round end')
    winteam = event_var['winner']
    if winteam == '2':
        winteam = '#t,#human'
        #winteam = '#t,#all'
    elif winteam == '3':
        winteam = '#ct,#human'
        #winteam = '#ct,#all'
    es.dbgmsg(1,'*****winteam=%s' %winteam)
    winners = playerlib.getPlayerList(winteam)
    es.dbgmsg(1,'*****winners=%s' %winners)
    if winners:
        for winner in winners:
            es.dbgmsg(1,'*****winner steamid=%s,userid=%s' %(winner.attributes['steamid'],es.getuserid(winner.attributes['steamid'])))
            steamid = winner.attributes['steamid']
            htp_dm.deposit(es.getuserid(steamid),steamid,None,None)
            			

def htp_deposit(event_var): 
    es.dbgmsg(1,'*****event htp_deposit received')
    es.dbgmsg(1,'*****userid=%s' %event_var['userid'])
    userid = event_var['userid']	
    steamid = event_var['steamid']
    weapon = event_var['weapon']
    headshot = event_var['headshot']
    allowdeposit = 0
    balance = dbba.query("SELECT balance FROM accounts WHERE steamid='%s'" %steamid)
    es.dbgmsg(1,'*****balance=%s' %balance)
    if balance:
        balance = int(balance[0][0])
        es.dbgmsg(1,'*****balance=%s' %balance)
        bonus = killcash
        balance = balance + killcash
        if int(headshot):
            if weapon != 'awp':
                balance = balance + headshotbonus
                bonus = bonus + headshotbonus
            else:
                if noawpbonus:
                    balance = balance + headshotbonus
                    bonus = bonus + headshotbonus
        if weapon == 'knife':
            balance = balance + knifebonus
        es.dbgmsg(1,'*****balance=%s, maxbalance=%d, ignoremax=%d' %(balance,maxbalance,ignoremax))
        if balance >= maxbalance:
            if ignoremax:
                allowdeposit = 1
        else:
            allowdeposit = 1
        if allowdeposit: 
            dbba.execute("UPDATE accounts SET balance='%d' WHERE steamid='%s'" %(balance,steamid))
            token = {'bonus':str(bonus)}
            es.dbgmsg(1,'*****bank_reward msg should follow')
            es.tell(userid, '#multi', prefix + dm_lang('bank_reward',token)) 

def htp_withdraw(event_var):
    es.dbgmsg(1,'*****event htp_withdraw received')
    es.dbgmsg(1,'*****userid=%s' %event_var['userid'])	
    if event_var['weapon'] == 'knife':
        steamid = event_var['steamid']
        balance = int(dbba.query("SELECT balance FROM accounts WHERE steamid='%s'" %steamid)[0][0])
        es.dbgmsg(1,'*****balance=%s' %balance)
        if balance:
            balance = balance - knifepenalty
            es.dbgmsg(1,'*****balance=%s' %balance)
            if balance >= minbalance:
                dbba.execute("UPDATE accounts SET balance='%d' WHERE steamid='%s'" %(balance,steamid))
                token = {'knifepenalty':str(knifepenalty)}
                es.tell(event_var['userid'], '#multi', prefix + dm_lang('bank_penalty',token))     

def unload():
    dbba.close